-------------------------------------------------------------------------------
--                L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local addonName, L = ...;

local raceInfo =
{
  [0] = -- Totals
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {0,  0},
    keystoneId     = 0,
    keystoneSize   = 0,
    fragmentId     = 0,
  },
  [1] = -- Demonic
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1174,
  },
  [2] = -- Highmountain Tauren
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1173,
  },
  [3] = -- Highbourne
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1172,
  },
  [4] = -- Ogre
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 828,
  },
  [5] = -- Draenor Clans
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 19},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 821,
  },
  [6] = -- Arakkoa
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 829,
  },
  [7] = -- Mogu
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 752,
  },
  [8] = -- Pandaren
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 676,
  },
  [9] = -- Mantid
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  8},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 754,
  },
  [10] = -- Vrykul
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 399,
  },
  [11] = -- Troll
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3, 14},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 385,
  },
  [12] = -- Tol'vir
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {6,  7},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 401,
  },
  [13] = -- Orc
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {1,  9},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 397,
  },
  [14] = -- Nerubian
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  7},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 400,
  },
  [15] = -- Night Elf
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {7, 18},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 394,
  },
  [16] = -- Fossil
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {5, 12},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 393,
  },
  [17] = -- Draenei
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  8},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 398,
  },
  [18] = -- Dwarf
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {4, 27},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 384,
  },
};

local lootIds = {};

-- Mapping of spell ID to item ID(s) for all archaeology projects
local artifactInfo =
{
  { 86857, 18, 63408},
  { 86864, 18, 63409},
  { 86865, 18, 63110},
  { 86866, 18, 63112},
  { 88180, 18, 63410},
  { 88181, 18, 63411},
  { 88262, 11, 63115},
  { 88907, 11, 63120},
  { 88908, 11, 63118},
  { 88909, 18, 63111},
  { 88910, 18, 63113},
  { 88929, 16, 63109},
  { 88930, 16, 63121},
  { 89009, 15, 63129},
  { 89012, 15, 63130},
  { 89014, 15, 63131},
  { 89693, 16, 60955},
  { 89696, 15, 63407},
  { 89701, 11, 63412},
  { 89711, 11, 63413},
  { 89717, 18, 63414},
  { 89890, 11, 63523},
  { 89891, 11, 63524},
  { 89893, 15, 63525},
  { 89894, 15, 63526},
  { 89895, 16, 63527},
  { 89896, 15, 63528},
  { 90410, 18, 64337},
  { 90411, 18, 64339},
  { 90412, 18, 64340},
  { 90413, 18, 64342},
  { 90415, 18, 64343},
  { 90419, 18, 64344},
  { 90420, 11, 64345},
  { 90421, 11, 64346},
  { 90423, 11, 64347},
  { 90429, 11, 64348},
  { 90432, 16, 64349},
  { 90433, 16, 64350},
  { 90451, 15, 64354},
  { 90452, 16, 64355},
  { 90453, 15, 64356},
  { 90458, 15, 64357},
  { 90464, 15, 64358},
  { 90493, 15, 64361},
  { 90504, 18, 64362},
  { 90506, 18, 64366},
  { 90509, 18, 64367},
  { 90518, 18, 64368},
  { 90519, 18, 64371},
  { 90521, 18, 64372},
  { 90553, 18, 64373},
  { 90558, 11, 64374},
  { 90581, 11, 64375},
  { 90608, 11, 64377},
  { 90609, 15, 64378},
  { 90610, 15, 64379},
  { 90611, 15, 64381},
  { 90612, 15, 64382},
  { 90614, 15, 64383},
  { 90616, 15, 64643},
  { 90617, 16, 64385},
  { 90618, 16, 64387},
  { 90619, 16, 60954},
  { 90622, 13, 64389},
  { 90720, 13, 64417},
  { 90728, 13, 64418},
  { 90730, 13, 64419},
  { 90732, 13, 64420},
  { 90734, 13, 64421},
  { 90831, 13, 64436},
  { 90832, 13, 64437},
  { 90833, 13, 64438},
  { 90843, 13, 64644},
  { 90853, 17, 64440},
  { 90860, 17, 64442},
  { 90861, 17, 64443},
  { 90864, 17, 64444},
  { 90968, 17, 64453},
  { 90974, 17, 64454},
  { 90975, 17, 64455},
  { 90983, 17, 64456},
  { 90984, 17, 64457},
  { 90987, 17, 64458},
  { 90988, 10, 64459},
  { 90997, 10, 64460},
  { 91008, 10, 64461},
  { 91012, 10, 64462},
  { 91014, 10, 64464},
  { 91084, 10, 64467},
  { 91089, 16, 64468},
  { 91132, 16, 64473},
  { 91133, 14, 64474},
  { 91170, 14, 64475},
  { 91188, 14, 64476},
  { 91191, 14, 64477},
  { 91197, 14, 64478},
  { 91209, 14, 64479},
  { 91211, 14, 64480},
  { 91214, 14, 64481},
  { 91215, 14, 64482},
  { 91219, 18, 64483},
  { 91221, 18, 64484},
  { 91223, 18, 64485},
  { 91224, 18, 64486},
  { 91225, 18, 64487},
  { 91226, 18, 64488},
  { 91227, 18, 64489},
  { 91757, 15, 64645},
  { 91761, 15, 64646},
  { 91762, 15, 64647},
  { 91766, 15, 64648},
  { 91769, 15, 64650},
  { 91773, 15, 64651},
  { 91775, 12, 64652},
  { 91779, 12, 64653},
  { 91780, 12, 64654},
  { 91782, 12, 64655},
  { 91785, 12, 64656},
  { 91790, 12, 64657},
  { 91792, 12, 64658},
  { 91793, 18, 64659},
  { 92137, 12, 60846},
  { 92139, 12, 64880},
  { 92145, 12, 64881},
  { 92148, 12, 64883},
  { 92163, 12, 64885},
  { 92168, 12, 64904},
  { 93440, 18, 66054},
  { 93441, 15, 66055},
  { 93442, 16, 66056},
  { 93443, 16, 66057},
  { 93444, 11, 66058},
  { 98533, 16, 69764},
  { 98556, 11, 69777},
  { 98560, 16, 69776},
  { 98569, 10, 69775},
  { 98582, 16, 69821},
  { 98588, 11, 69824},
  {113968,  8, {79896, 85557}},
  {113971,  8, {79897, 85558}},
  {113972,  8, {79898, 89178}},
  {113973,  8, {79899, 89179}},
  {113974,  8, {79900, 89180}},
  {113975,  8, {79901, 89181}},
  {113976,  8, {79902, 89182}},
  {113977,  8, {79903, 89183}},
  {113978,  8, {79904, 89184}},
  {113979,  8, {79905, 89185}},
  {113980,  8, 89684},
  {113981,  8, 89685},
  {113982,  7, {79908, 89169}},
  {113983,  7, {79909, 89170}},
  {113984,  7, {79910, 89171}},
  {113985,  7, {79911, 89172}},
  {113986,  7, {79912, 89173}},
  {113987,  7, {79913, 89174}},
  {113988,  7, {79914, 89175}},
  {113989,  7, {79915, 89176}},
  {113990,  7, {79916, 85477}},
  {113991,  7, {79917, 89209}},
  {113992,  7, 89611},
  {113993,  7, 89614},
  {139776,  9, {95375, 95383}},
  {139779,  9, {95376, 95384}},
  {139780,  9, {95377, 95385}},
  {139781,  9, {95378, 95386}},
  {139782,  9, {95379, 95387}},
  {139783,  9, {95380, 95388}},
  {139784,  9, {95381, 95389}},
  {139785,  9, {95382, 95390}},
  {139786,  9, 95391},
  {139787,  9, 95392},
  {168290,  5, {114141, 114142}},
  {168291,  5, {114143, 114144}},
  {168292,  5, {114145, 114146}},
  {168293,  5, {114147, 114148}},
  {168294,  5, {114149, 114150}},
  {168295,  5, {114151, 114152}},
  {168296,  5, {114153, 114154}},
  {168297,  5, {114155, 114156}},
  {168298,  5, {114157, 114158}},
  {168299,  5, {114159, 114160}},
  {168300,  5, {114161, 114162}},
  {168301,  5, {114163, 114164}},
  {168302,  5, {114165, 114166}},
  {168303,  5, {114167, 114168}},
  {168304,  5, {114169, 114170}},
  {168305,  5, {114171, 114172}},
  {168306,  5, {114173, 114174}},
  {168307,  5, {114175, 114176}},
  {168308,  5, {114177, 114178}},
  {168309,  4, {114181, 114182}},
  {168310,  4, {114183, 114184}},
  {168311,  4, {114185, 114186}},
  {168312,  4, {114187, 114188}},
  {168313,  4, {114189, 114208}},
  {168314,  4, {114190, 114209}},
  {168315,  4, {114191, 114210}},
  {168316,  4, {114192, 114211}},
  {168317,  4, {114193, 114212}},
  {168318,  4, {114194, 114213}},
  {168319,  4, 117385},
  {168320,  4, 117384},
  {168321,  6, {114197, 114215}},
  {168322,  6, {114198, 114216}},
  {168323,  6, {114199, 114217}},
  {168324,  6, {114200, 114218}},
  {168325,  6, {114201, 114219}},
  {168326,  6, {114202, 114220}},
  {168327,  6, {114203, 114221}},
  {168328,  6, {114204, 114222}},
  {168329,  6, {114205, 114223}},
  {168330,  6, {114206, 114224}},
  {168331,  6, 117382},
  {172459,  5, 116985},
  {172460,  6, 117354},
  {172466,  5, 117380},
  {196470,  3, {130906, 130921}},
  {196471,  3, {130907, 130922}},
  {196472,  3, {130908, 130923}},
  {196473,  3, {130909, 130924}},
  {196474,  3, {130910, 130925}},
  {196475,  2, {130911, 130926}},
  {196476,  2, {130912, 130927}},
  {196477,  2, {130913, 130928}},
  {196478,  2, {130914, 130929}},
  {196479,  2, {130915, 130930}},
  {196480,  1, {130916, 130931}},
  {196481,  1, {130917, 130932}},
  {196482,  1, {130918, 130933}},
  {196483,  1, {130919, 130934}},
  {196484,  1, {130920, 130935}},
};

local selectedRaceIdx = 0;

local summaryMarkers = {};

-------------------------------------------------------------------------------
--             L  O  C  A  L     D  E  F  I  N  I  T  I  O  N  S
-------------------------------------------------------------------------------

local archaeologyUpdateTotals;

-------------------------------------------------------------------------------
--                L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to add info about how many artifacts have been completed
--
local function archaeologyCompletedUpdate()
  -- Local Variables
  local frame = ArchaeologyFrameCompletedPage;
  local text;
  local artifactIdx = 0;
  local raceIdx = frame.raceFilter;

  -- Update the titles with the completed progress
  for _, title in ipairs({frame.titleTop, frame.titleMid}) do
    -- Check if the top title is displayed
    if (title:IsShown()) then
      -- Get the current text
      text = title:GetText();
      if ((text ~= nil) and (text ~= "")) then
        -- Work out the rarity for the title
        if (text:find(ARCHAEOLOGY_RARE_COMPLETED, 1, true)) then
          artifactIdx = 1;
          text        = ARCHAEOLOGY_RARE_COMPLETED;
        elseif (text:find(ARCHAEOLOGY_COMMON_COMPLETED, 1, true)) then
          artifactIdx = 2;
          text        = ARCHAEOLOGY_COMMON_COMPLETED;
        else
          artifactIdx = 0;
        end

        -- Update the title's text
        if (artifactIdx > 0) then
          if ((NigglesDBC.settings.ProfArchProgress == true) and
              (raceInfo[raceIdx].totalArtifacts[artifactIdx] > 0)) then
            text = text.."|n"..raceInfo[raceIdx].numArtifacts[artifactIdx]..
              "/"..raceInfo[raceIdx].totalArtifacts[artifactIdx];
          end
          title:SetText(text);
        end
      end
    end
  end

  return;
end

--
-- Function to process events
--
local function archaeologyOnEvent(self, event, ...)
  -- Process the event
  if ((event == "RESEARCH_ARTIFACT_UPDATE") or
      (event == "RESEARCH_ARTIFACT_COMPLETE")) then
    RequestArtifactCompletionHistory();
  elseif (event == "RESEARCH_ARTIFACT_HISTORY_READY") then
    archaeologyUpdateTotals();
  end

  return;
end

--
-- Function to update the progress of each race's artifact
--
local function archaeologySummaryUpdate()
  -- Local Variables
  local _;
  local bagIdx;
  local button;
  local summaryPage = ArchaeologyFrame.summaryPage;
  local itemCount;
  local itemId;
  local numFragments;
  local numAdjustment;
  local numRaces = GetNumArchaeologyRaces();
  local numRequired;
  local numSlots;
  local numSockets;
  local raceIdx;
  local raceKeystones = {};
  local raceName;
  local texture;

  -- Check if the archaeology panels should be enhanced
  if ((NigglesDBC.settings.ProfArchHilite == true) or
      (NigglesDBC.settings.ProfArchKeystones == true)) then
    -- Get the number of race keystones in the character's bags, if required
    if (NigglesDBC.settings.ProfArchKeystones) then
      for raceIdx = 1, numRaces do
        raceKeystones[raceIdx] = GetItemCount(raceInfo[raceIdx].keystoneId,
          false);
      end
    else
      raceKeystones = {};
    end

    -- Update the progress of each race's artifact
    for idx = 1, ARCHAEOLOGY_MAX_RACES do
      raceIdx = idx+(ARCHAEOLOGY_MAX_RACES*(summaryPage.currentPage-1));
      button  = summaryPage["race"..idx];
      if ((button ~= nil) and (raceIdx <= numRaces)) then
        -- Check if the player has started any artifacts for the race
        if (GetNumArtifactsByRace(raceIdx) > 0) then
          -- Get the number of fragments currently possessed and required
          raceName, _, _, numFragments, numRequired =
            GetArchaeologyRaceInfo(raceIdx);

          -- Update the number of fragments, if required
          numAdjustment = 0;
          if (NigglesDBC.settings.ProfArchKeystones == true) then
            -- Get the number of sockets the current artifact has
            SetSelectedArtifact(raceIdx);
            _, _, _, _, _, numSockets =  GetSelectedArtifactInfo();

            -- Update the number of fragments
            numAdjustment = (math.min(numSockets,
              (raceKeystones[raceIdx] or 0))*raceInfo[raceIdx].keystoneSize);
            numFragments = numFragments+numAdjustment;
          end

          -- Update the progress
          if ((NigglesDBC.settings.ProfArchHilite == true) and
              (numFragments >= numRequired)) then
            -- Create the marker, if required
            if (summaryMarkers[idx] == nil) then
              texture = button:CreateTexture(nil, "OVERLAY");
              texture:SetTexture("Interface\\RAIDFRAME\\ReadyCheck-Ready");
              texture:SetWidth(60);
              texture:SetHeight(60);
              texture:SetPoint("CENTER");
              summaryMarkers[idx] = texture;
            end

            -- Show the marker
            summaryMarkers[idx]:Show();
          elseif (summaryMarkers[idx] ~= nil) then
            -- Show the marker
            summaryMarkers[idx]:Hide();
          end

          -- Update the progress
          button.raceName:SetText(
            raceName.."|n"..numFragments..
            (numAdjustment > 0 and " (+"..numAdjustment..") " or "")..
            "/"..numRequired);
        end
      end
    end
  elseif (next(summaryMarkers) ~= nil) then
    -- Hide any markers
    for idx = 1, ARCHAEOLOGY_MAX_RACES do
      if (summaryMarkers[idx] ~= nil) then
        summaryMarkers[idx]:Hide();
      end
    end
  end

  return;
end

--
-- Function to generate a checksum for an artifact's name. It uses the
-- 'Fletcher16' algorithm and has been verified to generate unique checksums
-- for all artifact names as of 2013-07-01 for English, French, German,
-- Portuguese and Spanish.
--
local function getArtifactNameChecksum(name, raceIdx)
  -- Local Variables
  local band = bit.band;
  local min = math.min;
  local nameIdx = 1;
  local nameLen = string.len(name);
  local rshift = bit.rshift;
  local strbyte = string.byte;
  local sum1 = 0xFF;
  local sum2 = 0xFF;

  -- Process the name in 20-byte chunks
  while (nameIdx <= nameLen) do
    for blockIdx = nameIdx, min(nameLen, nameIdx+19) do
      sum1 = sum1+strbyte(name, blockIdx);
      sum2 = sum2+sum1;
    end
    sum1    = band(sum1, 0xFF)+rshift(sum1, 8);
    sum2    = band(sum2, 0xFF)+rshift(sum2, 8);
    nameIdx = nameIdx+20;
  end
  sum1 = band(sum1, 0xFF)+rshift(sum1, 8);
  sum2 = band(sum2, 0xFF)+rshift(sum2, 8);

  return bit.lshift(raceIdx, 16)+bit.lshift(sum2, 8)+sum1;
end

--
-- Function to update the number of completed artifacts for each race
--
archaeologyUpdateTotals = function()
  -- Local Variables
  local _;
  local rarity;
  local numArtifacts;
  local completed;
  local current;
  local totalArtifacts = raceInfo[0].numArtifacts;

  -- Check if the option is enabled
  if (NigglesDBC.settings.ProfArchProgress == true) then
    -- Reset the total number of artifacts
    totalArtifacts[1] = 0;
    totalArtifacts[2] = 0;

    -- Count the number of rare and common artifacts for each race
    for raceIdx = 1, #raceInfo do
      -- Assign the race's info to a more convenient variable
      current = raceInfo[raceIdx].numArtifacts;

      -- Reset the number of artifacts for the race
      current[1] = 0;
      current[2] = 0;

      -- Get the total number of artifacts for the race
      numArtifacts = GetNumArtifactsByRace(raceIdx);

      -- Count the number of rare and common artifacts for the race
      for artifactIdx = 1, numArtifacts do
        _, _, rarity, _, _, _, _, completed = GetArtifactInfoByRace(raceIdx,
          artifactIdx);
        -- Check the artifact has actually been completed
        if (completed > 0) then
          if (rarity == 1) then
            current[1] = current[1]+1;
          else
            current[2] = current[2]+1;
          end
        end
      end

      -- Update the total number of artifacts
      totalArtifacts[1] = totalArtifacts[1]+current[1];
      totalArtifacts[2] = totalArtifacts[2]+current[2];
    end

    -- Update the completed page, if it's shown
    if (ArchaeologyFrameCompletedPage:IsShown()) then
      archaeologyCompletedUpdate();
    end
  end

  return
end

-------------------------------------------------------------------------------
--                 A  D  D  O  N     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to enable/disable the Niggles Archaeology features
--
L.archaeologyEnable = function()
  -- Update the markers on the summary page, if required
  if ((ArchaeologyFrame ~= nil) and (ArchaeologyFrame.summaryPage ~= nil)) then
    archaeologySummaryUpdate()
  end

  return;
end

--
-- Function to initialise the Niggles Archaeology functionality
--
L.archaeologyInitialise = function()
  -- Local Variables
  local _;
  local itemId;
  local artifactName;
  local numRaces = #raceInfo;

  -- Get info about the races
  for idx = 1, numRaces do
    -- Get ID of the race's keystone
    _, _, raceInfo[idx].keystoneId = GetArchaeologyRaceInfo(idx);

    -- Add the race's keystone and fragment IDs to the loot IDs
    if (raceInfo[idx].keystoneId > 0) then
      lootIds[raceInfo[idx].keystoneId] = true;
    end
    if (raceInfo[idx].fragmentId > 0) then
      lootIds[-raceInfo[idx].fragmentId] = true;
    end

    -- Update the total number of artifacts
    raceInfo[0].totalArtifacts[1] =
      raceInfo[0].totalArtifacts[1]+raceInfo[idx].totalArtifacts[1];
    raceInfo[0].totalArtifacts[2] =
      raceInfo[0].totalArtifacts[2]+raceInfo[idx].totalArtifacts[2];
  end

  -- Get checksums for the names of the artifact spells
  for _, currentItem in ipairs(artifactInfo) do
    artifactName   = GetSpellInfo(currentItem[1]);
    currentItem[4] = getArtifactNameChecksum(artifactName, currentItem[2]);
  end

  return;
end

--
-- Function to check if an item is an archaeology keystone
--
L.archaeologyIsLoot = function(itemType, itemLink)
  -- Local Variables
  local itemId = 0;

  -- Extract the item ID from the specified item link
  if (itemType == LOOT_SLOT_CURRENCY) then
    itemId = -tonumber(string.match(itemLink, "|Hcurrency:(%d+)|h"));
  elseif (itemType == LOOT_SLOT_ITEM) then
    itemId = tonumber(string.match(itemLink, "|Hitem:(%d+):"));
  end

  -- Check if the item ID is for an archaeology keystone or fragment
  return (lootIds[itemId] ~= nil);
end

--
-- Function called when Blizzard's Archaeology addon is loaded
--
L.archaeologyOnLoad = function()
  -- Local Variables
  local frame;

  -- Add hooks to the functions used to update the pages
  hooksecurefunc("ArchaeologyFrame_UpdateSummary",
    archaeologySummaryUpdate);
  ArchaeologyFrame.summaryPage.UpdateFrame = ArchaeologyFrame_UpdateSummary;
  hooksecurefunc("ArchaeologyFrame_UpdateComplete",
    archaeologyCompletedUpdate);
  ArchaeologyFrame.completedPage.UpdateFrame = ArchaeologyFrame_UpdateComplete;

  -- Hook functions into the 'Prev' and 'Next' buttons on the 'Completed' page
  ArchaeologyFrameCompletedPagePrevPageButton:HookScript("OnMouseUp",
    NigglesFirstLastPage);
  ArchaeologyFrameCompletedPageNextPageButton:HookScript("OnMouseUp",
    NigglesFirstLastPage);

  -- Enable right clicking on the artifact page to go back to the summary page
  ArchaeologyFrameArtifactPage:EnableMouse(true);
  ArchaeologyFrameArtifactPage:HookScript("OnMouseUp",
    function(self, mouseButton)
      -- Local Variables
      local pageIdx;
      local summaryPage = ArchaeologyFrame.summaryPage;

      -- Check the option is enabled and the right button was clicked
      if ((NigglesDBC.settings.ProfArchRClickBack == true) and
          (mouseButton == "RightButton")) then
        -- Save the current page for the summary page
        pageIdx = summaryPage.currentPage;

        -- Mimic clicking the 'Summary' button
        ArchaeologyFrame_OnTabClick(ArchaeologyFrameSummarytButton);

        -- Mimic clicking 'Next Page' button until correct page is reached
        while ((summaryPage.currentPage < pageIdx) and
               (summaryPage.nextPageButton:IsEnabled())) do
          ArchaeologyFrameSummary_PageClick(summaryPage.nextPageButton, true);
        end
      end
    end);

  -- Create the frame used to provide a tooltip for the current artifact
  -- NOTE: This is done here, rather than in the XML file, because the
  --       Archaeology panel is implemented as an on-demand addon.
  frame = CreateFrame("Frame", "NigglesArtifactIcon",
    ArchaeologyFrameArtifactPage, "NigglesArtifactIconTemplate");
  frame:SetShown(NigglesDBC.settings.ProfArchEnhIcon);

  -- Register the frame for some events
  frame:RegisterEvent("RESEARCH_ARTIFACT_UPDATE");
  frame:RegisterEvent("RESEARCH_ARTIFACT_COMPLETE");
  frame:RegisterEvent("RESEARCH_ARTIFACT_HISTORY_READY");
  frame:HookScript("OnEvent", archaeologyOnEvent);

  -- Request artifact completion history from the server
  RequestArtifactCompletionHistory();

  -- Adjust the position of the races slightly on the Summary page
  ArchaeologyFrameSummaryPageRace1:SetPoint("TOPLEFT", 60, -75);

  return;
end

--
-- Function called when a race is selected for Archaeology
--
L.archaeologyOnSelect = function(raceIdx)
  -- Save the selected race
  selectedRaceIdx = raceIdx;

  return;
end

-------------------------------------------------------------------------------
--               G  L  O  B  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to find the spell ID for the specified artifact
--
function NigglesArchaeologyGetSpellId()
  -- Local Variables
  local artifactName = GetSelectedArtifactInfo();
  local checksum;
  local spellId = 0;

  -- Check the name of the selected artifact could be obtained
  if (artifactName ~= nil) then
    -- Get a checksum for the artifact's name
    checksum = getArtifactNameChecksum(artifactName, selectedRaceIdx);

    -- Search for the artifact's info
    for _, currentItem in ipairs(artifactInfo) do
      if (checksum == currentItem[4]) then
        spellId = currentItem[1];
        break;
      end
    end
  end

  return spellId;
end

--
-- Function to process a click on the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnClick(frame)
  -- Local Variables
  local artifactChecksum;
  local artifactName;
  local artifact = nil;
  local hyperlink;

  -- Get the name of the selected artifact & its checksum
  artifactName     = GetSelectedArtifactInfo();
  artifactChecksum = getArtifactNameChecksum(artifactName, selectedRaceIdx);

  -- Search for the artifact's info
  for idx, currentItem in ipairs(artifactInfo) do
    if (artifactChecksum == currentItem[4]) then
      artifact = currentItem;
      break;
    end
  end

  -- Check the artifact was found
  if (artifact ~= nil) then
    for _, itemId in
      ipairs(type(artifact[3]) == "table" and artifact[3] or {artifact[3]}) do
      -- Get the artifact's hyperlink
      _, hyperlink = GetItemInfo(itemId)
      if (hyperlink ~= nil) then
        -- Call the standard handler
        HandleModifiedItemClick(hyperlink);
      end
    end
  end

  return;
end

--
-- Function to display the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnEnter(frame)
  -- Local Variables
  local artifactChecksum = 0;
  local artifactName;
  local artifact = nil;
  local itemId;
  local prevTooltip = nil;
  local tooltip;

  -- Get the name of the selected artifact & its checksum
  artifactName     = GetSelectedArtifactInfo();
  artifactChecksum = getArtifactNameChecksum(artifactName, selectedRaceIdx);

  -- Search for the artifact's info
  for idx, currentItem in ipairs(artifactInfo) do
    if (artifactChecksum == currentItem[4]) then
      artifact = currentItem;
      break;
    end
  end

  -- Check the artifact was found
  if (artifact ~= nil) then
    -- Work out the ID of the item to display in the GameTooltip
    if (type(artifact[3]) == "table") then
      itemId = artifact[3][1];
    else
      itemId = artifact[3];
    end

    -- Set the first tooltip to the Game tooltip
    _G["NigglesTooltip1"] = GameTooltip;

    -- Display tooltips for all the artifact's items
    for idx, itemId in
      ipairs(type(artifact[3]) == "table" and artifact[3] or {artifact[3]}) do
      -- Make sure the tooltip exists
      if (_G["NigglesTooltip"..idx] == nil) then
        tooltip = CreateFrame("GameTooltip", "NigglesTooltip"..idx, nil,
          "GameTooltipTemplate");
      else
        tooltip = _G["NigglesTooltip"..idx];
      end

      -- Position the tooltip
      if (prevTooltip == nil) then
        tooltip:SetOwner(frame, "ANCHOR_BOTTOMRIGHT", 0);
      else
        tooltip:SetOwner(prevTooltip, "ANCHOR_NONE", 0);
        tooltip:ClearAllPoints();
        tooltip:SetPoint("TOPLEFT", prevTooltip, "TOPRIGHT", 0, 0);
      end
      prevTooltip = tooltip;

      -- Set the tooltip
      tooltip:SetItemByID(itemId);
      tooltip:Show();
    end
  end

  return;
end

--
-- Function to hide the tooltip(s) for an artifact
--
function NigglesArchaeologyTooltipOnLeave(frame)
  -- Local Variables
  local idx = 1;

  -- Hide all the Niggles tooltips
  while (_G["NigglesTooltip"..idx] ~= nil) do
    _G["NigglesTooltip"..idx]:Hide();
    idx = idx+1;
  end

  return;
end
